/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _573MP7JRSCONTENTCOLLECTIONTYPE_LOCALTYPE1_H
#define _573MP7JRSCONTENTCOLLECTIONTYPE_LOCALTYPE1_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsContentCollectionType_LocalType1Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtInclude.h


class IMp7JrsContentCollectionType;
class IMp7JrsContentCollectionType_LocalType1;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsContentCollectionType > Mp7JrsContentCollectionPtr;
typedef Mp7JrsPtr< IMp7JrsContentCollectionType_LocalType1> Mp7JrsContentCollectionType_Local1Ptr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsContentCollectionType_LocalType1 for class Mp7JrsContentCollectionType_LocalType1<br>
 */
class MP7JRS_EXPORT IMp7JrsContentCollectionType_LocalType1 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsContentCollectionType_LocalType1();
    virtual ~IMp7JrsContentCollectionType_LocalType1();
        /** @name Choice

         */
        //@{
    /**
     * Get ContentCollection element.
     * @return Mp7JrsContentCollectionPtr
     */
    virtual Mp7JrsContentCollectionPtr GetContentCollection() const = 0;

    /**
     * Set ContentCollection element.
     * @param item const Mp7JrsContentCollectionPtr &
     */
    virtual void SetContentCollection(const Mp7JrsContentCollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ContentCollectionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetContentCollectionRef() const = 0;

    /**
     * Set ContentCollectionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetContentCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtPropDef.h

};




/*
 * Generated class Mp7JrsContentCollectionType_LocalType1<br>
 * Defined in mds-2001.xsd, line 5249.<br>
 */
class MP7JRS_EXPORT Mp7JrsContentCollectionType_LocalType1 :
        public IMp7JrsContentCollectionType_LocalType1
{
    friend class Mp7JrsContentCollectionType_LocalType1Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get ContentCollection element.
     * @return Mp7JrsContentCollectionPtr
     */
    virtual Mp7JrsContentCollectionPtr GetContentCollection() const;

    /*
     * Set ContentCollection element.
     * @param item const Mp7JrsContentCollectionPtr &
     */
    virtual void SetContentCollection(const Mp7JrsContentCollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ContentCollectionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetContentCollectionRef() const;

    /*
     * Set ContentCollectionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetContentCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsContentCollectionType_LocalType1();

protected:
    Mp7JrsContentCollectionType_LocalType1();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsContentCollectionPtr m_ContentCollection;
    Mp7JrsReferencePtr m_ContentCollectionRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _573MP7JRSCONTENTCOLLECTIONTYPE_LOCALTYPE1_H

