/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

#ifndef _592MP7JRSCONTINUOUSHIDDENMARKOVMODELTYPE_OBSERVATIONDISTRIBUTION_COLLECTIONTYPEFACTORY_H
#define _592MP7JRSCONTINUOUSHIDDENMARKOVMODELTYPE_OBSERVATIONDISTRIBUTION_COLLECTIONTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory<br>
 * for class Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionType:<br>
 * Located at: mds-2001.xsd, line 5645<br>
 * Abstract item type: ContinuousDistributionType<br>
 * Possible classes:<br>
 * \li ContinuousUniformDistributionType (Class)<br>
 * \li ExponentialDistributionType (Class)<br>
 * \li GammaDistributionType (Class)<br>
 * \li GaussianDistributionType (Class)<br>
 * \li GaussianMixtureModelType (Class)<br>
 * \li GeneralizedGaussianDistributionType (Class)<br>
 * \li LognormalDistributionType (Class)<br>
 */

class MP7JRS_EXPORT Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory :
    public Mp7JrsFactory
{
public:
    Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory();
    virtual ~Mp7JrsContinuousHiddenMarkovModelType_ObservationDistribution_CollectionTypeFactory();
	
    virtual const char * GetTypeName() const; // Formerly GetObjectType()
    virtual Mp7JrsNodePtr CreateObject();
};

#endif // _592MP7JRSCONTINUOUSHIDDENMARKOVMODELTYPE_OBSERVATIONDISTRIBUTION_COLLECTIONTYPEFACTORY_H
