/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/


#ifndef MP7JRS_CONVERT_H
#define MP7JRS_CONVERT_H

#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

/** Type conversions. */
class MP7JRS_EXPORT Mp7JrsConvert
{
public:
	static XMLCh * BinToText(int src);
	static XMLCh * BinToText(unsigned int src);
	static XMLCh * BinToText(float src);
	static XMLCh * BinToText(double src);

	static int TextToInt(const XMLCh* text);
	static unsigned int TextToUnsignedInt(const XMLCh * text);
	static bool TextToBool(const XMLCh* text);
	static XMLCh * TextToString(const XMLCh * text);
	static float TextToFloat(const XMLCh * text);
	static double TextToDouble(const XMLCh * text);

	// Convert "-" or "+" to -1 or +1, must be able to deal with strings like "-123"
	static int TextToSign(const XMLCh * text);


private:
	Mp7JrsConvert();
	~Mp7JrsConvert();
};



#endif // MP7JRS_CONVERT_H
