/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _795MP7JRSEDITEDVIDEOEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H
#define _795MP7JRSEDITEDVIDEOEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtInclude.h


class IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType;
class IMp7JrsGlobalTransitionType;
class IMp7JrsReferenceType;
class IMp7JrsShotType;
typedef Mp7JrsPtr< IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType> Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsGlobalTransitionType > Mp7JrsGlobalTransitionPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsShotType > Mp7JrsShotPtr;

/** 
 * Generated interface IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType for class Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType();
    virtual ~IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get Shot element.
     * @return Mp7JrsShotPtr
     */
    virtual Mp7JrsShotPtr GetShot() const = 0;

    /**
     * Set Shot element.
     * @param item const Mp7JrsShotPtr &
     */
    // Mandatory			
    virtual void SetShot(const Mp7JrsShotPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ShotRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetShotRef() const = 0;

    /**
     * Set ShotRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get GlobalTransition element.
     * @return Mp7JrsGlobalTransitionPtr
     */
    virtual Mp7JrsGlobalTransitionPtr GetGlobalTransition() const = 0;

    /**
     * Set GlobalTransition element.
     * @param item const Mp7JrsGlobalTransitionPtr &
     */
    // Mandatory			
    virtual void SetGlobalTransition(const Mp7JrsGlobalTransitionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get GlobalTransitionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetGlobalTransitionRef() const = 0;

    /**
     * Set GlobalTransitionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetGlobalTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType<br>
 * Defined in mds-2001.xsd, line 4002.<br>
 */
class MP7JRS_EXPORT Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType :
        public IMp7JrsEditedVideoEditingTemporalDecompositionType_LocalType
{
    friend class Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get Shot element.
     * @return Mp7JrsShotPtr
     */
    virtual Mp7JrsShotPtr GetShot() const;

    /*
     * Set Shot element.
     * @param item const Mp7JrsShotPtr &
     */
    // Mandatory			
    virtual void SetShot(const Mp7JrsShotPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ShotRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetShotRef() const;

    /*
     * Set ShotRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get GlobalTransition element.
     * @return Mp7JrsGlobalTransitionPtr
     */
    virtual Mp7JrsGlobalTransitionPtr GetGlobalTransition() const;

    /*
     * Set GlobalTransition element.
     * @param item const Mp7JrsGlobalTransitionPtr &
     */
    // Mandatory			
    virtual void SetGlobalTransition(const Mp7JrsGlobalTransitionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get GlobalTransitionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetGlobalTransitionRef() const;

    /*
     * Set GlobalTransitionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetGlobalTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType();

protected:
    Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
// DefinionChoice
    Mp7JrsShotPtr m_Shot;
    Mp7JrsReferencePtr m_ShotRef;
// End DefinionChoice
// DefinionChoice
    Mp7JrsGlobalTransitionPtr m_GlobalTransition;
    Mp7JrsReferencePtr m_GlobalTransitionRef;
// End DefinionChoice
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsEditedVideoEditingTemporalDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _795MP7JRSEDITEDVIDEOEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

