/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1091MP7JRSINTRACOMPOSITIONSHOTEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H
#define _1091MP7JRSINTRACOMPOSITIONSHOTEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType_ExtInclude.h


class IMp7JrsInternalTransitionType;
class IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType;
class IMp7JrsIntraCompositionShotType;
class IMp7JrsReferenceType;
typedef Mp7JrsPtr< IMp7JrsInternalTransitionType > Mp7JrsInternalTransitionPtr;
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType> Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsIntraCompositionShotType > Mp7JrsIntraCompositionShotPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;

/** 
 * Generated interface IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType for class Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType();
    virtual ~IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType();
        /** @name Sequence

         */
        //@{
        /** @name Choice

         */
        //@{
        /** @name Choice

         */
        //@{
    /**
     * Get IntraCompositionShot element.
     * @return Mp7JrsIntraCompositionShotPtr
     */
    virtual Mp7JrsIntraCompositionShotPtr GetIntraCompositionShot() const = 0;

    /**
     * Set IntraCompositionShot element.
     * @param item const Mp7JrsIntraCompositionShotPtr &
     */
    // Mandatory			
    virtual void SetIntraCompositionShot(const Mp7JrsIntraCompositionShotPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get IntraCompositionShotRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetIntraCompositionShotRef() const = 0;

    /**
     * Set IntraCompositionShotRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetIntraCompositionShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        /** @name Choice

         */
        //@{
    /**
     * Get InternalTransition element.
     * @return Mp7JrsInternalTransitionPtr
     */
    virtual Mp7JrsInternalTransitionPtr GetInternalTransition() const = 0;

    /**
     * Set InternalTransition element.
     * @param item const Mp7JrsInternalTransitionPtr &
     */
    // Mandatory			
    virtual void SetInternalTransition(const Mp7JrsInternalTransitionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get InternalTransitionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetInternalTransitionRef() const = 0;

    /**
     * Set InternalTransitionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetInternalTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
        //@}
        //@}
// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType<br>
 * Defined in mds-2001.xsd, line 4114.<br>
 */
class MP7JRS_EXPORT Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType :
        public IMp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType
{
    friend class Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
        /* @name Choice

         */
        //@{
        /* @name Choice

         */
        //@{
    /*
     * Get IntraCompositionShot element.
     * @return Mp7JrsIntraCompositionShotPtr
     */
    virtual Mp7JrsIntraCompositionShotPtr GetIntraCompositionShot() const;

    /*
     * Set IntraCompositionShot element.
     * @param item const Mp7JrsIntraCompositionShotPtr &
     */
    // Mandatory			
    virtual void SetIntraCompositionShot(const Mp7JrsIntraCompositionShotPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get IntraCompositionShotRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetIntraCompositionShotRef() const;

    /*
     * Set IntraCompositionShotRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetIntraCompositionShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        /* @name Choice

         */
        //@{
    /*
     * Get InternalTransition element.
     * @return Mp7JrsInternalTransitionPtr
     */
    virtual Mp7JrsInternalTransitionPtr GetInternalTransition() const;

    /*
     * Set InternalTransition element.
     * @param item const Mp7JrsInternalTransitionPtr &
     */
    // Mandatory			
    virtual void SetInternalTransition(const Mp7JrsInternalTransitionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get InternalTransitionRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetInternalTransitionRef() const;

    /*
     * Set InternalTransitionRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    // Mandatory			
    virtual void SetInternalTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
        //@}
        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType();

protected:
    Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
// DefinionChoice
    Mp7JrsIntraCompositionShotPtr m_IntraCompositionShot;
    Mp7JrsReferencePtr m_IntraCompositionShotRef;
// End DefinionChoice
// DefinionChoice
    Mp7JrsInternalTransitionPtr m_InternalTransition;
    Mp7JrsReferencePtr m_InternalTransitionRef;
// End DefinionChoice
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsIntraCompositionShotEditingTemporalDecompositionType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1091MP7JRSINTRACOMPOSITIONSHOTEDITINGTEMPORALDECOMPOSITIONTYPE_LOCALTYPE_H

