/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1175MP7JRSMEDIAFORMATTYPE_VISUALCODING_FRAME_LOCALTYPE_H
#define _1175MP7JRSMEDIAFORMATTYPE_VISUALCODING_FRAME_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaFormatType_VisualCoding_Frame_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType_ExtInclude.h


#include "Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType.h"
class IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType;
class IMp7JrsnonNegativeReal;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType> Mp7JrsMediaFormatType_VisualCoding_Frame_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsnonNegativeReal > Mp7JrsnonNegativeRealPtr;

/** 
 * Generated interface IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType for class Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType<br>
 * Located at: mds-2001.xsd, line 2230<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType();
    virtual ~IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType();
    /**
     * Get height attribute.
     * @return unsigned
     */
    virtual unsigned Getheight() const = 0;

    /**
     * Get height attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existheight() const = 0;

    /**
     * Set height attribute.
     * @param item unsigned
     */
    virtual void Setheight(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate height attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateheight() = 0;

    /**
     * Get width attribute.
     * @return unsigned
     */
    virtual unsigned Getwidth() const = 0;

    /**
     * Get width attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existwidth() const = 0;

    /**
     * Set width attribute.
     * @param item unsigned
     */
    virtual void Setwidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate width attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatewidth() = 0;

    /**
     * Get aspectRatio attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetaspectRatio() const = 0;

    /**
     * Get aspectRatio attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistaspectRatio() const = 0;

    /**
     * Set aspectRatio attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void SetaspectRatio(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate aspectRatio attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateaspectRatio() = 0;

    /**
     * Get rate attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr Getrate() const = 0;

    /**
     * Get rate attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrate() const = 0;

    /**
     * Set rate attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void Setrate(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate rate attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterate() = 0;

    /**
     * Get structure attribute.
     * @return Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration Getstructure() const = 0;

    /**
     * Get structure attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existstructure() const = 0;

    /**
     * Set structure attribute.
     * @param item Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration
     */
    virtual void Setstructure(Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate structure attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatestructure() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of MediaFormatType_VisualCoding_Frame_LocalType.
     * Currently just supports rudimentary XPath expressions as MediaFormatType_VisualCoding_Frame_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType<br>
 * Located at: mds-2001.xsd, line 2230<br>
 * Classified: Class<br>
 * Defined in mds-2001.xsd, line 2230.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType :
        public IMp7JrsMediaFormatType_VisualCoding_Frame_LocalType
{
    friend class Mp7JrsMediaFormatType_VisualCoding_Frame_LocalTypeFactory; // constructs objects

public:
    /*
     * Get height attribute.
     * @return unsigned
     */
    virtual unsigned Getheight() const;

    /*
     * Get height attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existheight() const;

    /*
     * Set height attribute.
     * @param item unsigned
     */
    virtual void Setheight(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate height attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateheight();

    /*
     * Get width attribute.
     * @return unsigned
     */
    virtual unsigned Getwidth() const;

    /*
     * Get width attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existwidth() const;

    /*
     * Set width attribute.
     * @param item unsigned
     */
    virtual void Setwidth(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate width attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatewidth();

    /*
     * Get aspectRatio attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr GetaspectRatio() const;

    /*
     * Get aspectRatio attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool ExistaspectRatio() const;

    /*
     * Set aspectRatio attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void SetaspectRatio(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate aspectRatio attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateaspectRatio();

    /*
     * Get rate attribute.
     * @return Mp7JrsnonNegativeRealPtr
     */
    virtual Mp7JrsnonNegativeRealPtr Getrate() const;

    /*
     * Get rate attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existrate() const;

    /*
     * Set rate attribute.
     * @param item const Mp7JrsnonNegativeRealPtr &
     */
    virtual void Setrate(const Mp7JrsnonNegativeRealPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate rate attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidaterate();

    /*
     * Get structure attribute.
     * @return Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration
     */
    virtual Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration Getstructure() const;

    /*
     * Get structure attribute validity information.
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existstructure() const;

    /*
     * Set structure attribute.
     * @param item Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration
     */
    virtual void Setstructure(Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate structure attribute.
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatestructure();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of MediaFormatType_VisualCoding_Frame_LocalType.
     * Currently just supports rudimentary XPath expressions as MediaFormatType_VisualCoding_Frame_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType();

protected:
    Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
    unsigned m_height;
    bool m_height_Exist;
    unsigned m_width;
    bool m_width_Exist;
    Mp7JrsnonNegativeRealPtr m_aspectRatio;
    bool m_aspectRatio_Exist;
    Mp7JrsnonNegativeRealPtr m_rate;
    bool m_rate_Exist;
    Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration m_structure;
    bool m_structure_Exist;



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1175MP7JRSMEDIAFORMATTYPE_VISUALCODING_FRAME_LOCALTYPE_H

