/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1461MP7JRSNONMIXTUREAMOUNTOFMOTIONTYPE_H
#define _1461MP7JRSNONMIXTUREAMOUNTOFMOTIONTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNonMixtureAmountOfMotionTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtInclude.h


class IMp7JrsNonMixtureAmountOfMotionType;
class IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType;
class IMp7Jrsunsigned11;
typedef Mp7JrsPtr< IMp7JrsNonMixtureAmountOfMotionType_Fixed_LocalType > Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsNonMixtureAmountOfMotionType> Mp7JrsNonMixtureAmountOfMotionPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned11 > Mp7Jrsunsigned11Ptr;

/** 
 * Generated interface IMp7JrsNonMixtureAmountOfMotionType for class Mp7JrsNonMixtureAmountOfMotionType<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 914<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsNonMixtureAmountOfMotionType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsNonMixtureAmountOfMotionType();
    virtual ~IMp7JrsNonMixtureAmountOfMotionType();
        /** @name Choice

         */
        //@{
    /**
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackLeft() const = 0;

    /**
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TrackRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackRight() const = 0;

    /**
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get BoomDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomDown() const = 0;

    /**
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get BoomUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomUp() const = 0;

    /**
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DollyForward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyForward() const = 0;

    /**
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyBackward() const = 0;

    /**
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PanLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanLeft() const = 0;

    /**
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get PanRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanRight() const = 0;

    /**
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TiltDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltDown() const = 0;

    /**
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TiltUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltUp() const = 0;

    /**
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollClockwise() const = 0;

    /**
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollAnticlockwise() const = 0;

    /**
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomIn() const = 0;

    /**
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomOut() const = 0;

    /**
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Fixed element.
     * @return Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr
     */
    virtual Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr GetFixed() const = 0;

    /**
     * Set Fixed element.
     * @param item const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr &
     */
    // Mandatory			
    virtual void SetFixed(const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Gets or creates Mp7JrsNodePtr child elements of NonMixtureAmountOfMotionType.
     * Currently this type contains 15 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>TrackLeft</li>
     * <li>TrackRight</li>
     * <li>BoomDown</li>
     * <li>BoomUp</li>
     * <li>DollyForward</li>
     * <li>DollyBackward</li>
     * <li>PanLeft</li>
     * <li>PanRight</li>
     * <li>TiltDown</li>
     * <li>TiltUp</li>
     * <li>RollClockwise</li>
     * <li>RollAnticlockwise</li>
     * <li>ZoomIn</li>
     * <li>ZoomOut</li>
     * <li>Fixed</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsNonMixtureAmountOfMotionType<br>
 * Located at: visual-2001.with.net.workaround.xsd, line 914<br>
 * Classified: Class<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 914.<br>
 */
class MP7JRS_EXPORT Mp7JrsNonMixtureAmountOfMotionType :
        public IMp7JrsNonMixtureAmountOfMotionType
{
    friend class Mp7JrsNonMixtureAmountOfMotionTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get TrackLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackLeft() const;

    /*
     * Set TrackLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTrackLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TrackRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTrackRight() const;

    /*
     * Set TrackRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTrackRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get BoomDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomDown() const;

    /*
     * Set BoomDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetBoomDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get BoomUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetBoomUp() const;

    /*
     * Set BoomUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetBoomUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DollyForward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyForward() const;

    /*
     * Set DollyForward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetDollyForward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DollyBackward element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetDollyBackward() const;

    /*
     * Set DollyBackward element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetDollyBackward(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PanLeft element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanLeft() const;

    /*
     * Set PanLeft element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetPanLeft(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get PanRight element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetPanRight() const;

    /*
     * Set PanRight element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetPanRight(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TiltDown element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltDown() const;

    /*
     * Set TiltDown element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTiltDown(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TiltUp element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetTiltUp() const;

    /*
     * Set TiltUp element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetTiltUp(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RollClockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollClockwise() const;

    /*
     * Set RollClockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetRollClockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get RollAnticlockwise element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetRollAnticlockwise() const;

    /*
     * Set RollAnticlockwise element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetRollAnticlockwise(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ZoomIn element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomIn() const;

    /*
     * Set ZoomIn element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetZoomIn(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ZoomOut element.
     * @return Mp7Jrsunsigned11Ptr
     */
    virtual Mp7Jrsunsigned11Ptr GetZoomOut() const;

    /*
     * Set ZoomOut element.
     * @param item const Mp7Jrsunsigned11Ptr &
     */
    // Mandatory			
    virtual void SetZoomOut(const Mp7Jrsunsigned11Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Fixed element.
     * @return Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr
     */
    virtual Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr GetFixed() const;

    /*
     * Set Fixed element.
     * @param item const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr &
     */
    // Mandatory			
    virtual void SetFixed(const Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Gets or creates Mp7JrsNodePtr child elements of NonMixtureAmountOfMotionType.
     * Currently this type contains 15 child elements of type "Mp7JrsNodePtr".

     * <ul>
     * <li>TrackLeft</li>
     * <li>TrackRight</li>
     * <li>BoomDown</li>
     * <li>BoomUp</li>
     * <li>DollyForward</li>
     * <li>DollyBackward</li>
     * <li>PanLeft</li>
     * <li>PanRight</li>
     * <li>TiltDown</li>
     * <li>TiltUp</li>
     * <li>RollClockwise</li>
     * <li>RollAnticlockwise</li>
     * <li>ZoomIn</li>
     * <li>ZoomOut</li>
     * <li>Fixed</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsNonMixtureAmountOfMotionType();

protected:
    Mp7JrsNonMixtureAmountOfMotionType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7Jrsunsigned11Ptr m_TrackLeft;
    Mp7Jrsunsigned11Ptr m_TrackRight;
    Mp7Jrsunsigned11Ptr m_BoomDown;
    Mp7Jrsunsigned11Ptr m_BoomUp;
    Mp7Jrsunsigned11Ptr m_DollyForward;
    Mp7Jrsunsigned11Ptr m_DollyBackward;
    Mp7Jrsunsigned11Ptr m_PanLeft;
    Mp7Jrsunsigned11Ptr m_PanRight;
    Mp7Jrsunsigned11Ptr m_TiltDown;
    Mp7Jrsunsigned11Ptr m_TiltUp;
    Mp7Jrsunsigned11Ptr m_RollClockwise;
    Mp7Jrsunsigned11Ptr m_RollAnticlockwise;
    Mp7Jrsunsigned11Ptr m_ZoomIn;
    Mp7Jrsunsigned11Ptr m_ZoomOut;
    Mp7JrsNonMixtureAmountOfMotionType_Fixed_LocalPtr m_Fixed;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsNonMixtureAmountOfMotionType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1461MP7JRSNONMIXTUREAMOUNTOFMOTIONTYPE_H

