/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1571MP7JRSPERSONNAMETYPE_LOCALTYPE_H
#define _1571MP7JRSPERSONNAMETYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPersonNameType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsPersonNameType_LocalType_ExtInclude.h


class IMp7JrsNameComponentType;
class IMp7JrsPersonNameType_LocalType;
typedef Mp7JrsPtr< IMp7JrsNameComponentType > Mp7JrsNameComponentPtr;
typedef Mp7JrsPtr< IMp7JrsPersonNameType_LocalType> Mp7JrsPersonNameType_LocalPtr;

/** 
 * Generated interface IMp7JrsPersonNameType_LocalType for class Mp7JrsPersonNameType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsPersonNameType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPersonNameType_LocalType();
    virtual ~IMp7JrsPersonNameType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get GivenName element.
     * @return Mp7JrsNameComponentPtr
     */
    virtual Mp7JrsNameComponentPtr GetGivenName() const = 0;

    /**
     * Set GivenName element.
     * @param item const Mp7JrsNameComponentPtr &
     */
    // Mandatory			
    virtual void SetGivenName(const Mp7JrsNameComponentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get FamilyName element.
     * @return Mp7JrsNameComponentPtr
     */
    virtual Mp7JrsNameComponentPtr GetFamilyName() const = 0;

    virtual bool IsValidFamilyName() const = 0;

    /**
     * Set FamilyName element.
     * @param item const Mp7JrsNameComponentPtr &
     */
    virtual void SetFamilyName(const Mp7JrsNameComponentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate FamilyName element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFamilyName() = 0;

    /**
     * Get Title element.
     * @return Mp7JrsNameComponentPtr
     */
    virtual Mp7JrsNameComponentPtr GetTitle() const = 0;

    virtual bool IsValidTitle() const = 0;

    /**
     * Set Title element.
     * @param item const Mp7JrsNameComponentPtr &
     */
    virtual void SetTitle(const Mp7JrsNameComponentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Title element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTitle() = 0;

    /**
     * Get Numeration element.
     * @return XMLCh *
     */
    virtual XMLCh * GetNumeration() const = 0;

    virtual bool IsValidNumeration() const = 0;

    /**
     * Set Numeration element.
     * @param item XMLCh *
     */
    virtual void SetNumeration(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate Numeration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateNumeration() = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsPersonNameType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPersonNameType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPersonNameType_LocalType<br>
 * Defined in mds-2001.xsd, line 1826.<br>
 */
class MP7JRS_EXPORT Mp7JrsPersonNameType_LocalType :
        public IMp7JrsPersonNameType_LocalType
{
    friend class Mp7JrsPersonNameType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get GivenName element.
     * @return Mp7JrsNameComponentPtr
     */
    virtual Mp7JrsNameComponentPtr GetGivenName() const;

    /*
     * Set GivenName element.
     * @param item const Mp7JrsNameComponentPtr &
     */
    // Mandatory			
    virtual void SetGivenName(const Mp7JrsNameComponentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get FamilyName element.
     * @return Mp7JrsNameComponentPtr
     */
    virtual Mp7JrsNameComponentPtr GetFamilyName() const;

    virtual bool IsValidFamilyName() const;

    /*
     * Set FamilyName element.
     * @param item const Mp7JrsNameComponentPtr &
     */
    virtual void SetFamilyName(const Mp7JrsNameComponentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate FamilyName element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateFamilyName();

    /*
     * Get Title element.
     * @return Mp7JrsNameComponentPtr
     */
    virtual Mp7JrsNameComponentPtr GetTitle() const;

    virtual bool IsValidTitle() const;

    /*
     * Set Title element.
     * @param item const Mp7JrsNameComponentPtr &
     */
    virtual void SetTitle(const Mp7JrsNameComponentPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Title element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateTitle();

    /*
     * Get Numeration element.
     * @return XMLCh *
     */
    virtual XMLCh * GetNumeration() const;

    virtual bool IsValidNumeration() const;

    /*
     * Set Numeration element.
     * @param item XMLCh *
     */
    virtual void SetNumeration(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate Numeration element.
     
     * (Validate it again by setting a value)
     */
    virtual void InvalidateNumeration();

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPersonNameType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPersonNameType_LocalType();

protected:
    Mp7JrsPersonNameType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsNameComponentPtr m_GivenName;
    Mp7JrsNameComponentPtr m_FamilyName;
    bool m_FamilyName_Exist; // For optional elements 
    Mp7JrsNameComponentPtr m_Title;
    bool m_Title_Exist; // For optional elements 
    XMLCh * m_Numeration;
    bool m_Numeration_Exist; // For optional elements 
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsPersonNameType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1571MP7JRSPERSONNAMETYPE_LOCALTYPE_H

