/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1647MP7JRSPREFERENCECONDITIONTYPE_TIME_RECURRENCE_LOCALTYPE1_H
#define _1647MP7JRSPREFERENCECONDITIONTYPE_TIME_RECURRENCE_LOCALTYPE1_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1_ExtInclude.h


class IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1;
typedef Mp7JrsPtr< IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1> Mp7JrsPreferenceConditionType_Time_recurrence_Local1Ptr;

/** 
 * Generated interface IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1 for class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1<br>
 * Located at: mds-2001.xsd, line 5834<br>
 * Derived from: anyURI (String)<br>
 */
class MP7JRS_EXPORT IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1();
    virtual ~IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1();
    /**
     * Sets the content of Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Retrieves the content of Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1 
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of PreferenceConditionType_Time_recurrence_LocalType1.
     * Currently just supports rudimentary XPath expressions as PreferenceConditionType_Time_recurrence_LocalType1 contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1_ExtPropDef.h

};




/*
 * Generated class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1<br>
 * Located at: mds-2001.xsd, line 5834<br>
 * Derived from: anyURI (String)<br>
 * Defined in mds-2001.xsd, line 5834.<br>
 */
class MP7JRS_EXPORT Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1 :
        public IMp7JrsPreferenceConditionType_Time_recurrence_LocalType1
{
    friend class Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1Factory; // constructs objects

public:
    /*
     * Sets the content of Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1     * @param item XMLCh *
     */
    virtual void SetContent(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Retrieves the content of Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1 
     * @return XMLCh *
     */
    virtual XMLCh * GetContent() const;

    /*
     * Gets or creates Mp7JrsNodePtr child elements of PreferenceConditionType_Time_recurrence_LocalType1.
     * Currently just supports rudimentary XPath expressions as PreferenceConditionType_Time_recurrence_LocalType1 contains no child elements of type "Mp7JrsNodePtr" at all.

     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
	virtual bool ContentFromString(const XMLCh * const txt);

    /* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
     * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
     */
	virtual XMLCh * ContentToString() const;


    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1();

protected:
    Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base String
    XMLCh * m_Base;


// no includefile for extension defined 
// file Mp7JrsPreferenceConditionType_Time_recurrence_LocalType1_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1647MP7JRSPREFERENCECONDITIONTYPE_TIME_RECURRENCE_LOCALTYPE1_H

