/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _1969MP7JRSSPACEFREQUENCYGRAPHTYPE_LOCALTYPE0_H
#define _1969MP7JRSSPACEFREQUENCYGRAPHTYPE_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpaceFrequencyGraphType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtInclude.h


class IMp7JrsReferenceType;
class IMp7JrsSpaceFrequencyGraphType;
class IMp7JrsSpaceFrequencyGraphType_LocalType0;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType > Mp7JrsSpaceFrequencyGraphPtr;
typedef Mp7JrsPtr< IMp7JrsSpaceFrequencyGraphType_LocalType0> Mp7JrsSpaceFrequencyGraphType_Local0Ptr;

/** 
 * Generated interface IMp7JrsSpaceFrequencyGraphType_LocalType0 for class Mp7JrsSpaceFrequencyGraphType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsSpaceFrequencyGraphType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpaceFrequencyGraphType_LocalType0();
    virtual ~IMp7JrsSpaceFrequencyGraphType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get FrequencyChild element.
     * @return Mp7JrsSpaceFrequencyGraphPtr
     */
    virtual Mp7JrsSpaceFrequencyGraphPtr GetFrequencyChild() const = 0;

    /**
     * Set FrequencyChild element.
     * @param item const Mp7JrsSpaceFrequencyGraphPtr &
     */
    virtual void SetFrequencyChild(const Mp7JrsSpaceFrequencyGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get FrequencyChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetFrequencyChildRef() const = 0;

    /**
     * Set FrequencyChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpaceFrequencyGraphType_LocalType0<br>
 * Defined in mds-2001.xsd, line 5088.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpaceFrequencyGraphType_LocalType0 :
        public IMp7JrsSpaceFrequencyGraphType_LocalType0
{
    friend class Mp7JrsSpaceFrequencyGraphType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get FrequencyChild element.
     * @return Mp7JrsSpaceFrequencyGraphPtr
     */
    virtual Mp7JrsSpaceFrequencyGraphPtr GetFrequencyChild() const;

    /*
     * Set FrequencyChild element.
     * @param item const Mp7JrsSpaceFrequencyGraphPtr &
     */
    virtual void SetFrequencyChild(const Mp7JrsSpaceFrequencyGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get FrequencyChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetFrequencyChildRef() const;

    /*
     * Set FrequencyChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpaceFrequencyGraphType_LocalType0();

protected:
    Mp7JrsSpaceFrequencyGraphType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsSpaceFrequencyGraphPtr m_FrequencyChild;
    Mp7JrsReferencePtr m_FrequencyChildRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyGraphType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _1969MP7JRSSPACEFREQUENCYGRAPHTYPE_LOCALTYPE0_H

