/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2007MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE_H
#define _2007MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType_ExtInclude.h


class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType> Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr;

/** 
 * Generated interface IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType for class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType();
    virtual ~IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType();
        /** @name Sequence

         */
        //@{
    /**
     * Get Pixel element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr GetPixel() const = 0;

    /**
     * Set Pixel element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr &
     */
    // Mandatory			
    virtual void SetPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get CoordPoint element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr GetCoordPoint() const = 0;

    /**
     * Set CoordPoint element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr &
     */
    // Mandatory			
    virtual void SetCoordPoint(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 120.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType :
        public IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType
{
    friend class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalTypeFactory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get Pixel element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr GetPixel() const;

    /*
     * Set Pixel element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr &
     */
    // Mandatory			
    virtual void SetPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get CoordPoint element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr GetCoordPoint() const;

    /*
     * Set CoordPoint element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr &
     */
    // Mandatory			
    virtual void SetCoordPoint(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType();

protected:
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Pixel_LocalPtr m_Pixel;
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CoordPoint_LocalPtr m_CoordPoint;

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2007MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE_H

