/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2009MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE0_H
#define _2009MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtInclude.h


class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0;
class IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0> Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType > Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr;

/** 
 * Generated interface IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 for class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0();
    virtual ~IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0();
        /** @name Sequence

         */
        //@{
    /**
     * Get CurrPixel element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr GetCurrPixel() const = 0;

    /**
     * Set CurrPixel element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr &
     */
    // Mandatory			
    virtual void SetCurrPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SrcPixel element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr GetSrcPixel() const = 0;

    /**
     * Set SrcPixel element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr &
     */
    // Mandatory			
    virtual void SetSrcPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0<br>
 * Defined in visual-2001.with.net.workaround.xsd, line 136.<br>
 */
class MP7JRS_EXPORT Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 :
        public IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0
{
    friend class Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0Factory; // constructs objects

public:
        /* @name Sequence

         */
        //@{
    /*
     * Get CurrPixel element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr GetCurrPixel() const;

    /*
     * Set CurrPixel element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr &
     */
    // Mandatory			
    virtual void SetCurrPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SrcPixel element.
     * @return Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr
     */
    virtual Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr GetSrcPixel() const;

    /*
     * Set SrcPixel element.
     * @param item const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr &
     */
    // Mandatory			
    virtual void SetSrcPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0();

protected:
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr m_CurrPixel;
    Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr m_SrcPixel;

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2009MP7JRSSPATIAL2DCOORDINATESYSTEMTYPE_LOCALCOORDINATESYSTEM_LOCALTYPE0_H

