/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2163MP7JRSSTRUCTUREDCOLLECTIONTYPE_LOCALTYPE1_H
#define _2163MP7JRSSTRUCTUREDCOLLECTIONTYPE_LOCALTYPE1_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsStructuredCollectionType_LocalType1Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType1_ExtInclude.h


class IMp7JrsClusterModelType;
class IMp7JrsReferenceType;
class IMp7JrsStructuredCollectionType_LocalType1;
typedef Mp7JrsPtr< IMp7JrsClusterModelType > Mp7JrsClusterModelPtr;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsStructuredCollectionType_LocalType1> Mp7JrsStructuredCollectionType_Local1Ptr;

/** 
 * Generated interface IMp7JrsStructuredCollectionType_LocalType1 for class Mp7JrsStructuredCollectionType_LocalType1<br>
 */
class MP7JRS_EXPORT IMp7JrsStructuredCollectionType_LocalType1 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsStructuredCollectionType_LocalType1();
    virtual ~IMp7JrsStructuredCollectionType_LocalType1();
        /** @name Choice

         */
        //@{
    /**
     * Get ClusterModel element.
     * @return Mp7JrsClusterModelPtr
     */
    virtual Mp7JrsClusterModelPtr GetClusterModel() const = 0;

    /**
     * Set ClusterModel element.
     * @param item const Mp7JrsClusterModelPtr &
     */
    virtual void SetClusterModel(const Mp7JrsClusterModelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get ClusterModelRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetClusterModelRef() const = 0;

    /**
     * Set ClusterModelRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetClusterModelRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType1_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType1_ExtPropDef.h

};




/*
 * Generated class Mp7JrsStructuredCollectionType_LocalType1<br>
 * Defined in mds-2001.xsd, line 5359.<br>
 */
class MP7JRS_EXPORT Mp7JrsStructuredCollectionType_LocalType1 :
        public IMp7JrsStructuredCollectionType_LocalType1
{
    friend class Mp7JrsStructuredCollectionType_LocalType1Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get ClusterModel element.
     * @return Mp7JrsClusterModelPtr
     */
    virtual Mp7JrsClusterModelPtr GetClusterModel() const;

    /*
     * Set ClusterModel element.
     * @param item const Mp7JrsClusterModelPtr &
     */
    virtual void SetClusterModel(const Mp7JrsClusterModelPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get ClusterModelRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetClusterModelRef() const;

    /*
     * Set ClusterModelRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetClusterModelRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType1_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsStructuredCollectionType_LocalType1();

protected:
    Mp7JrsStructuredCollectionType_LocalType1();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsClusterModelPtr m_ClusterModel;
    Mp7JrsReferencePtr m_ClusterModelRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType1_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2163MP7JRSSTRUCTUREDCOLLECTIONTYPE_LOCALTYPE1_H

