/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2295MP7JRSTEXTANNOTATIONTYPE_LOCALTYPE_H
#define _2295MP7JRSTEXTANNOTATIONTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsTextAnnotationType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsTextAnnotationType_LocalType_ExtInclude.h


class IMp7JrsDependencyStructureType;
class IMp7JrsKeywordAnnotationType;
class IMp7JrsStructuredAnnotationType;
class IMp7JrsTextAnnotationType_LocalType;
class IMp7JrsTextualType;
typedef Mp7JrsPtr< IMp7JrsDependencyStructureType > Mp7JrsDependencyStructurePtr;
typedef Mp7JrsPtr< IMp7JrsKeywordAnnotationType > Mp7JrsKeywordAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsStructuredAnnotationType > Mp7JrsStructuredAnnotationPtr;
typedef Mp7JrsPtr< IMp7JrsTextAnnotationType_LocalType> Mp7JrsTextAnnotationType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsTextualType > Mp7JrsTextualPtr;

/** 
 * Generated interface IMp7JrsTextAnnotationType_LocalType for class Mp7JrsTextAnnotationType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsTextAnnotationType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsTextAnnotationType_LocalType();
    virtual ~IMp7JrsTextAnnotationType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get FreeTextAnnotation element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetFreeTextAnnotation() const = 0;

    /**
     * Set FreeTextAnnotation element.
     * @param item const Mp7JrsTextualPtr &
     */
    // Mandatory			
    virtual void SetFreeTextAnnotation(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get StructuredAnnotation element.
     * @return Mp7JrsStructuredAnnotationPtr
     */
    virtual Mp7JrsStructuredAnnotationPtr GetStructuredAnnotation() const = 0;

    /**
     * Set StructuredAnnotation element.
     * @param item const Mp7JrsStructuredAnnotationPtr &
     */
    // Mandatory			
    virtual void SetStructuredAnnotation(const Mp7JrsStructuredAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get DependencyStructure element.
     * @return Mp7JrsDependencyStructurePtr
     */
    virtual Mp7JrsDependencyStructurePtr GetDependencyStructure() const = 0;

    /**
     * Set DependencyStructure element.
     * @param item const Mp7JrsDependencyStructurePtr &
     */
    // Mandatory			
    virtual void SetDependencyStructure(const Mp7JrsDependencyStructurePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get KeywordAnnotation element.
     * @return Mp7JrsKeywordAnnotationPtr
     */
    virtual Mp7JrsKeywordAnnotationPtr GetKeywordAnnotation() const = 0;

    /**
     * Set KeywordAnnotation element.
     * @param item const Mp7JrsKeywordAnnotationPtr &
     */
    // Mandatory			
    virtual void SetKeywordAnnotation(const Mp7JrsKeywordAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsTextAnnotationType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsTextAnnotationType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsTextAnnotationType_LocalType<br>
 * Defined in mds-2001.xsd, line 1181.<br>
 */
class MP7JRS_EXPORT Mp7JrsTextAnnotationType_LocalType :
        public IMp7JrsTextAnnotationType_LocalType
{
    friend class Mp7JrsTextAnnotationType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get FreeTextAnnotation element.
     * @return Mp7JrsTextualPtr
     */
    virtual Mp7JrsTextualPtr GetFreeTextAnnotation() const;

    /*
     * Set FreeTextAnnotation element.
     * @param item const Mp7JrsTextualPtr &
     */
    // Mandatory			
    virtual void SetFreeTextAnnotation(const Mp7JrsTextualPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get StructuredAnnotation element.
     * @return Mp7JrsStructuredAnnotationPtr
     */
    virtual Mp7JrsStructuredAnnotationPtr GetStructuredAnnotation() const;

    /*
     * Set StructuredAnnotation element.
     * @param item const Mp7JrsStructuredAnnotationPtr &
     */
    // Mandatory			
    virtual void SetStructuredAnnotation(const Mp7JrsStructuredAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get DependencyStructure element.
     * @return Mp7JrsDependencyStructurePtr
     */
    virtual Mp7JrsDependencyStructurePtr GetDependencyStructure() const;

    /*
     * Set DependencyStructure element.
     * @param item const Mp7JrsDependencyStructurePtr &
     */
    // Mandatory			
    virtual void SetDependencyStructure(const Mp7JrsDependencyStructurePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get KeywordAnnotation element.
     * @return Mp7JrsKeywordAnnotationPtr
     */
    virtual Mp7JrsKeywordAnnotationPtr GetKeywordAnnotation() const;

    /*
     * Set KeywordAnnotation element.
     * @param item const Mp7JrsKeywordAnnotationPtr &
     */
    // Mandatory			
    virtual void SetKeywordAnnotation(const Mp7JrsKeywordAnnotationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsTextAnnotationType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsTextAnnotationType_LocalType();

protected:
    Mp7JrsTextAnnotationType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsTextualPtr m_FreeTextAnnotation;
    Mp7JrsStructuredAnnotationPtr m_StructuredAnnotation;
    Mp7JrsDependencyStructurePtr m_DependencyStructure;
    Mp7JrsKeywordAnnotationPtr m_KeywordAnnotation;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsTextAnnotationType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2295MP7JRSTEXTANNOTATIONTYPE_LOCALTYPE_H

