/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// ClassType_H.template
#ifndef _2533MP7JRSVIDEOVIEWGRAPHTYPE_LOCALTYPE_H
#define _2533MP7JRSVIDEOVIEWGRAPHTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVideoViewGraphType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtInclude.h


class IMp7JrsReferenceType;
class IMp7JrsVideoViewGraphType;
class IMp7JrsVideoViewGraphType_LocalType;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType > Mp7JrsVideoViewGraphPtr;
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType_LocalType> Mp7JrsVideoViewGraphType_LocalPtr;

/** 
 * Generated interface IMp7JrsVideoViewGraphType_LocalType for class Mp7JrsVideoViewGraphType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsVideoViewGraphType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsVideoViewGraphType_LocalType();
    virtual ~IMp7JrsVideoViewGraphType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get SpaceFrequencyChild element.
     * @return Mp7JrsVideoViewGraphPtr
     */
    virtual Mp7JrsVideoViewGraphPtr GetSpaceFrequencyChild() const = 0;

    /**
     * Set SpaceFrequencyChild element.
     * @param item const Mp7JrsVideoViewGraphPtr &
     */
    virtual void SetSpaceFrequencyChild(const Mp7JrsVideoViewGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SpaceFrequencyChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSpaceFrequencyChildRef() const = 0;

    /**
     * Set SpaceFrequencyChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSpaceFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVideoViewGraphType_LocalType<br>
 * Defined in mds-2001.xsd, line 5109.<br>
 */
class MP7JRS_EXPORT Mp7JrsVideoViewGraphType_LocalType :
        public IMp7JrsVideoViewGraphType_LocalType
{
    friend class Mp7JrsVideoViewGraphType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get SpaceFrequencyChild element.
     * @return Mp7JrsVideoViewGraphPtr
     */
    virtual Mp7JrsVideoViewGraphPtr GetSpaceFrequencyChild() const;

    /*
     * Set SpaceFrequencyChild element.
     * @param item const Mp7JrsVideoViewGraphPtr &
     */
    virtual void SetSpaceFrequencyChild(const Mp7JrsVideoViewGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SpaceFrequencyChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetSpaceFrequencyChildRef() const;

    /*
     * Set SpaceFrequencyChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetSpaceFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVideoViewGraphType_LocalType();

protected:
    Mp7JrsVideoViewGraphType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsVideoViewGraphPtr m_SpaceFrequencyChild;
    Mp7JrsReferencePtr m_SpaceFrequencyChildRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();

};

#endif // _2533MP7JRSVIDEOVIEWGRAPHTYPE_LOCALTYPE_H

