/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/


#ifndef _2577MP7JRSWORDFORMTYPE_TYPE_LOCALTYPE_H
#define _2577MP7JRSWORDFORMTYPE_TYPE_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsWordFormType_type_LocalType<br>
 * Located at: mds-2001.xsd, line 1306<br>
 * Enumerations: <br>
 * noun (mapped to XML noun) <br>
 * pronoun (mapped to XML pronoun) <br>
 * adjective (mapped to XML adjective) <br>
 * verb (mapped to XML verb) <br>
 * adverb (mapped to XML adverb) <br>
 * conjunction (mapped to XML conjunction) <br>
 * preposition (mapped to XML preposition) <br>
 * postposition (mapped to XML postposition) <br>
 * article (mapped to XML article) <br>
 * interjection (mapped to XML interjection) <br>
 */
class MP7JRS_EXPORT Mp7JrsWordFormType_type_LocalType
{
public:
	/** Mp7JrsWordFormType_type_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		noun, // Mapped to noun
		pronoun, // Mapped to pronoun
		adjective, // Mapped to adjective
		verb, // Mapped to verb
		adverb, // Mapped to adverb
		conjunction, // Mapped to conjunction
		preposition, // Mapped to preposition
		postposition, // Mapped to postposition
		article, // Mapped to article
		interjection, // Mapped to interjection
	};
	

// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsWordFormType_type_LocalType::Enumeration item);
	static Mp7JrsWordFormType_type_LocalType::Enumeration Parse(const XMLCh * const txt);

// no includefile for extension defined 
// file Mp7JrsWordFormType_type_LocalType_ExtPropDef.h


};
#endif // _2577MP7JRSWORDFORMTYPE_TYPE_LOCALTYPE_H
