/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// PatternType_H

#ifndef _607MP7JRSCOUNTRYCODE_H
#define _607MP7JRSCOUNTRYCODE_H


#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrscountryCodeFactory.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>
#include "Mp7JrsConvert.h"

// no includefile for extension defined 
// file Mp7JrscountryCode_ExtInclude.h



/**
 * Generated interface IMp7JrscountryCode for Pattern Mp7JrscountryCode
 */
class MP7JRS_EXPORT IMp7JrscountryCode :
	public Mp7JrsNode
{
public:
	virtual XMLCh * GetContent() const = 0;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


// no includefile for extension defined 
// file Mp7JrscountryCode_ExtMethodDef.h


};

/*
 * Generated pattern Mp7JrscountryCode<br>
 * Located at: mds-2001.xsd, line 824<br>
 * Regular expression: <br>
 * [a-zA-Z]{2}<br>
 * Mapped to string<br>
 */
class MP7JRS_EXPORT Mp7JrscountryCode :
	public IMp7JrscountryCode
{
	friend class Mp7JrscountryCodeFactory;
	
public: 
	virtual XMLCh * GetContent() const;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	virtual XMLCh * ToText() const;
	virtual bool Parse(const XMLCh * const txt);
	virtual bool ContentFromString(const XMLCh * const txt);

	virtual XMLCh * ContentToString() const;

	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent,  XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

// no includefile for extension defined 
// file Mp7JrscountryCode_ExtMyMethodDef.h


	virtual ~Mp7JrscountryCode();

protected:
	Mp7JrscountryCode();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);
	virtual Mp7JrsNodeEnum GetAllChildElements() const { return Mp7JrsNodeEnum(); }

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	XMLCh * m_Content;

// no includefile for extension defined 
// file Mp7JrscountryCode_ExtPropDef.h


protected:
	void Init();
	void Cleanup();
};

#endif // _607MP7JRSCOUNTRYCODE_H

