/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// PatternType_H

#ifndef _1283MP7JRSMIMETYPE_H
#define _1283MP7JRSMIMETYPE_H


#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsmimeTypeFactory.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>
#include "Mp7JrsConvert.h"

// no includefile for extension defined 
// file Mp7JrsmimeType_ExtInclude.h



/**
 * Generated interface IMp7JrsmimeType for Pattern Mp7JrsmimeType
 */
class MP7JRS_EXPORT IMp7JrsmimeType :
	public Mp7JrsNode
{
public:
	virtual XMLCh * GetContent() const = 0;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


// no includefile for extension defined 
// file Mp7JrsmimeType_ExtMethodDef.h


};

/*
 * Generated pattern Mp7JrsmimeType<br>
 * Located at: mds-2001.xsd, line 814<br>
 * Regular expression: <br>
 * [!--[\(\)<>@,;:\\"/\[\]\?=]]+/[!--[\(\)<>@,;:\\"/\[\]\?=]]+<br>
 * Mapped to string<br>
 */
class MP7JRS_EXPORT Mp7JrsmimeType :
	public IMp7JrsmimeType
{
	friend class Mp7JrsmimeTypeFactory;
	
public: 
	virtual XMLCh * GetContent() const;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	virtual XMLCh * ToText() const;
	virtual bool Parse(const XMLCh * const txt);
	virtual bool ContentFromString(const XMLCh * const txt);

	virtual XMLCh * ContentToString() const;

	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent,  XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

// no includefile for extension defined 
// file Mp7JrsmimeType_ExtMyMethodDef.h


	virtual ~Mp7JrsmimeType();

protected:
	Mp7JrsmimeType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);
	virtual Mp7JrsNodeEnum GetAllChildElements() const { return Mp7JrsNodeEnum(); }

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	XMLCh * m_Content;

// no includefile for extension defined 
// file Mp7JrsmimeType_ExtPropDef.h


protected:
	void Init();
	void Cleanup();
};

#endif // _1283MP7JRSMIMETYPE_H

