/*****************************************************************************/
/* Copyright (C) 2003-2007, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/* This software may only be used under the terms of the JRS MPEG-7 Library  */
/* license, available at                                                     */
/* http://iis.joanneum.at/MPEG-7/JRS-MPEG-7-Lib-License.pdf                  */
/*****************************************************************************/

// PatternType_H

#ifndef _2595MP7JRSXPATHFIELDTYPE_H
#define _2595MP7JRSXPATHFIELDTYPE_H


#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsxPathFieldTypeFactory.h"
#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>
#include "Mp7JrsConvert.h"

// no includefile for extension defined 
// file Mp7JrsxPathFieldType_ExtInclude.h



/**
 * Generated interface IMp7JrsxPathFieldType for Pattern Mp7JrsxPathFieldType
 */
class MP7JRS_EXPORT IMp7JrsxPathFieldType :
	public Mp7JrsNode
{
public:
	virtual XMLCh * GetContent() const = 0;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


// no includefile for extension defined 
// file Mp7JrsxPathFieldType_ExtMethodDef.h


};

/*
 * Generated pattern Mp7JrsxPathFieldType<br>
 * Located at: mds-2001.xsd, line 896<br>
 * Regular expression: <br>
 * (\.//)?((((child::)?((\i\c*:)?(\i\c*|\*)))|\.)/)*((((child::)?((\i\c*:)?(\i\c*|\*)))|\.)|((attribute::|@)((\i\c*:)?(\i\c*|\*))))(\|(\.//)?((((child::)?((\i\c*:)?(\i\c*|\*)))|\.)/)*((((child::)?((\i\c*:)?(\i\c*|\*)))|\.)|((attribute::|@)((\i\c*:)?(\i\c*|\*)))))*<br>
 * Mapped to string<br>
 */
class MP7JRS_EXPORT Mp7JrsxPathFieldType :
	public IMp7JrsxPathFieldType
{
	friend class Mp7JrsxPathFieldTypeFactory;
	
public: 
	virtual XMLCh * GetContent() const;

	virtual void SetContent(XMLCh * val, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	virtual XMLCh * ToText() const;
	virtual bool Parse(const XMLCh * const txt);
	virtual bool ContentFromString(const XMLCh * const txt);

	virtual XMLCh * ContentToString() const;

	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent,  XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

// no includefile for extension defined 
// file Mp7JrsxPathFieldType_ExtMyMethodDef.h


	virtual ~Mp7JrsxPathFieldType();

protected:
	Mp7JrsxPathFieldType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);
	virtual Mp7JrsNodeEnum GetAllChildElements() const { return Mp7JrsNodeEnum(); }

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	XMLCh * m_Content;

// no includefile for extension defined 
// file Mp7JrsxPathFieldType_ExtPropDef.h


protected:
	void Init();
	void Cleanup();
};

#endif // _2595MP7JRSXPATHFIELDTYPE_H

